unit Common.Exceptions;

interface

uses
  System.Classes, System.SysUtils;

type

  /// <summary>EBaseException
  /// </summary>
  EBaseException = class(Exception)
  end;


  /// <summary>base class for technical exceptions</summary>
  ETechnicalException = class(EBaseException)

  end;

  /// <summary>special descendant</summary>
  EFileException = class(EBaseException)
  private
    FFilename: String;
  public
    constructor Create(const Message, filename: String);
    property Filename: String read FFilename write FFilename;
  end;



  /// <summary>several tech exceptions produce logical exceptions</summary>
  ELogicalException = class(EBaseException)

  end;

  /// <summary>Exceptions presented to the user</summary>
  EUserException = class(ELogicalException)
  private
    FUserErrorID: Integer;
  public
    constructor Create(const aMessage: string; aUserErrorID: Integer);
    property UserErrorID: Integer read FUserErrorID write FUserErrorID;
  end;

implementation

{ EUserException }

constructor EUserException.Create(const aMessage: string;
  aUserErrorID: Integer);
begin
  inherited Create(message);
  FUserErrorID := aUserErrorID
end;

{ EFileException }

constructor EFileException.Create(const Message, filename: String);
begin
  inherited Create(message);
  FFilename := filename;
end;

end.
